【BZOJ】3339: Rmq Problem & 3585: mex(线段树+特殊的技巧)

http://www.lydsy.com/JudgeOnline/problem.php?id=3585

好神的题。

但是!!!!!!!!!!!!!!我线段树现在要开8倍空间才能过!!!!!!!!!!这什么梗。。。。。。。。。。。。。。。。。。。。。。

我思考了很久空间的问题,因为我在pushdown的时候可能会越界,或许是pushup?

不管了。然后看了zyf的写法。看来以后得注意下。。。pushdown弄成先放了。。。

本题的做法:

好神orz

首先像莫队一样离线区间,左端点在前。

考虑如何从[l, r]转移到[l+1, r]:

显然,a[l]此时是去掉了,l+1~next[l]是空着了a[l]这个自然数的。next[l]是下一个a[l]的位置。

所以我们直接线段树更新l+1~next[i]的sg值即可!即如果这个区间内有询问的sg值>a[l],那么更新!

好神。

#include <cstdio>
#include <cstring>
#include <cmath>
#include <string>
#include <iostream>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
#define rep(i, n) for(int i=0; i<(n); ++i)
#define for1(i,a,n) for(int i=(a);i<=(n);++i)
#define for2(i,a,n) for(int i=(a);i<(n);++i)
#define for3(i,a,n) for(int i=(a);i>=(n);--i)
#define for4(i,a,n) for(int i=(a);i>(n);--i)
#define CC(i,a) memset(i,a,sizeof(i))
#define read(a) a=getint()
#define print(a) printf("%d", a)
#define dbg(x) cout << (#x) << " = " << (x) << endl
#define error(x) (!(x)?puts("error"):0)
#define rdm(x, i) for(int i=ihead[x]; i; i=e[i].next)
inline const int getint() { int r=0, k=1; char c=getchar(); for(; c<‘0‘||c>‘9‘; c=getchar()) if(c==‘-‘) k=-1; for(; c>=‘0‘&&c<=‘9‘; c=getchar()) r=r*10+c-‘0‘; return k*r; }

#define lc x<<1
#define rc x<<1|1
#define MID (l+r)>>1
#define lson l, mid, lc
#define rson mid+1, r, rc

const int N=200005, oo=~0u>>1;
struct dat { int l, r, id; }q[N];
int sg[N], mn[N<<2];
void upd(int x, int k) { mn[x]=min(mn[x], k); }
void pushdown(int x) {
	if(mn[x]!=oo) {
		upd(lc, mn[x]);
		upd(rc, mn[x]);
		mn[x]=oo;
	}
}
void build(int l, int r, int x) {
	if(l==r) { mn[x]=sg[l]; return; }
	mn[x]=oo;
	int mid=MID;
	build(lson); build(rson);
}
void update(int l, int r, int x, int L, int R, int k) {
	if(L<=l && r<=R) { mn[x]=min(mn[x], k); return; }
	pushdown(x);
	int mid=MID;
	if(L<=mid) update(lson, L, R, k);
	if(mid<R) update(rson, L, R, k);
}
int query(int l, int r, int x, int k) {
	if(l==r) return mn[x];
	pushdown(x);
	int mid=MID;
	if(k<=mid) return query(lson, k);
	return query(rson, k);
}
int a[N], b[N], n, m, tot, vis[N], ans[N], inext[N];

void getnext() {
	for1(i, 1, n) b[i]=a[i];
	sort(b+1, b+1+n); tot=unique(b+1, b+1+n)-b-1;
	for1(i, 1, n) a[i]=lower_bound(b+1, b+1+tot, a[i])-b;
	for1(i, 1, tot) vis[i]=0;
	for3(i, n, 1) inext[i]=vis[a[i]], vis[a[i]]=i;
}
bool cmp(const dat &a, const dat &b) { return a.l<b.l; }
void init() {
	int k=0;
	for1(i, 1, n) {
		if(a[i]<N) vis[a[i]]=1;
		while(vis[k]) ++k;
		sg[i]=k;
	}
	build(1, n, 1);
	sort(q+1, q+1+m, cmp);
	getnext();
	int now=1;
	for1(i, 1, m) {
		int l=q[i].l;
		while(now<l) {
			int nxt=inext[now];
			if(nxt==0) nxt=n;
			else --nxt; // printf("now:%d nxt:%d a[now]:%d\n", now, nxt, b[a[now]]);
			if(now+1<=nxt) update(1, n, 1, now+1, nxt, b[a[now]]);
			++now;
		}
		ans[q[i].id]=query(1, n, 1, q[i].r);
	}
	for1(i, 1, m) printf("%d\n", ans[i]);
}

int main() {
	read(n); read(m);
	for1(i, 1, n) read(a[i]);
	for1(i, 1, m) read(q[i].l), read(q[i].r), q[i].id=i;
	init();
	return 0;
}

  


Description

  有一个长度为n的数组{a1,a2,...,an}。m次询问,每次询问一个区间内最小没有出现过的自然数。

Input

  第一行n,m。
  第二行为n个数。
  从第三行开始,每行一个询问l,r。

Output

  一行一个数,表示每个询问的答案。

Sample Input

5 5
2 1 0 2 1
3 3
2 3
2 4
1 2
3 5

Sample Output

1
2
3
0
3

HINT

数据规模和约定

  对于100%的数据:

  1<=n,m<=200000

  0<=ai<=109

  1<=l<=r<=n

  对于30%的数据:

  1<=n,m<=1000

Source

By 佚名提供

时间: 2024-10-05 02:38:51

【BZOJ】3339: Rmq Problem & 3585: mex(线段树+特殊的技巧)的相关文章

bzoj 3339: Rmq Problem

3339: Rmq Problem Time Limit: 20 Sec  Memory Limit: 128 MBSubmit: 1270  Solved: 666[Submit][Status][Discuss] Description Input Output Sample Input 7 5 0 2 1 0 1 3 2 1 3 2 3 1 4 3 6 2 7 Sample Output 3 0 3 2 4 HINT Source By Xhr 嗯,莫队 懒得敲线段树,毕竟线段树比较短 #

BZOJ.3585.mex(线段树)

题目链接 考虑\([1,i]\)的\(mex[i]\),显然是单调的 而对于\([l,r]\)与\([l+1,r]\),如果\(nxt[a[l]]>r\),那么\([l+1,r]\)中所有\(>a[l]\)的数显然要改成\(a[l]\) 询问排序,离散化,预处理下nxt[],剩下就是线段树的区间更新.查询了 /* 离散化的时候>=n的全部看做n就好了 查询时是只需查r点的(l之前能更新r的已经更新完了,初始时是[1,r],r点现在就是[l,r]了) 单点即可不需要PushUp(也不好得某

BZOJ - 3339: Rmq BZOJ - 3585: mex

3339: Rmq Problem 3585: mex 题解:分块维护权值,用莫队转移. 分块修改操作$O(1)$,查询$O(\sqrt{A_{max}})$.莫队转移$O(m\sqrt n)$.总共是$O(m\sqrt n)$ 一份代码解决两道题.额外的经验! 1 #include<cmath> 2 #include<algorithm> 3 #include<cstdio> 4 #include<iostream> 5 using namespace s

CodeForces 52C Circular RMQ(区间循环线段树,区间更新,区间求和)

转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://codeforces.com/problemset/problem/52/C You are given circular array a0,?a1,?...,?an?-?1. There are two types of operations with it: inc(lf,?rg,?v) - this operation increases each element on the segm

hihoCoder #1077 RMQ问题再临-线段树

#1077 : RMQ问题再临-线段树 Time Limit:10000ms Case Time Limit:1000ms Memory Limit:256MB 描述 上回说到:小Hi给小Ho出了这样一道问题:假设整个货架上从左到右摆放了N种商品,并且依次标号为1到N,每次小Hi都给出一段区间[L, R],小Ho要做的是选出标号在这个区间内的所有商品重量最轻的一种,并且告诉小Hi这个商品的重量.但是在这个过程中,可能会因为其他人的各种行为,对某些位置上的商品的重量产生改变(如更换了其他种类的商品

Uva 12299 RMQ with Shifts(线段树 + 单点更新 )

Uva 12299 RMQ with Shifts (线段树 + 单点更新) 题意: 对于给定的序列 x[i]给出一个操作 shift(a,b,c,d,e) 对应的是将 x[a]与x[b] x[b]与x[c] 这样相邻的两两交换For example, if A={6, 2, 4, 8, 5, 1, 4}then shift(2, 4, 5, 7) yields {6, 8, 4, 5, 4, 1, 2}. After that,shift(1, 2) yields {8, 6, 4, 5, 4

POJ 3468 A Simple Problem with Integers(线段树区间更新)

题目地址:POJ 3468 打了个篮球回来果然神经有点冲动..无脑的狂交了8次WA..居然是更新的时候把r-l写成了l-r... 这题就是区间更新裸题.区间更新就是加一个lazy标记,延迟标记,只有向下查询的时候才将lazy标记向下更新.其他的均按线段树的来就行. 代码如下: #include <iostream> #include <cstdio> #include <cstring> #include <math.h> #include <stac

HDU4267 A Simple Problem with Integers 线段树/树状数组

HDU4267 A Simple Problem with Integers  线段树/树状数组 2012长春网络赛A题 Problem Description Let A1, A2, ... , AN be N elements. You need to deal with two kinds of operations. One type of operation is to add a given number to a few numbers in a given interval. T

HDU 5371 Hotaru&#39;s problem manacher+(线段树or set)

题意,给定一个100000 的串,求他一个子串,使得将子串分成三部分有后,第一部分=第三部分,第一部分与第二部分对称(回文) 首先我们需要处理出以i为轴的回文串的两端,这个事情可以用Manacher算法完成,复杂度O(n) http://blog.csdn.net/ggggiqnypgjg/article/details/6645824/ 这个博客写的很好懂.不会的童鞋可以去学习一下这个算法,非常精妙. 好的现在我们已经会了这个算法,并获得了每个点为轴的串的右端点p[i] 很简单地可以处理出左端